Index: src/apps/debuganalyzer/gui/thread_window/ActivityPage.cpp
===================================================================
--- src/apps/debuganalyzer/gui/thread_window/ActivityPage.cpp	(Revision 34761)
+++ src/apps/debuganalyzer/gui/thread_window/ActivityPage.cpp	(Arbeitskopie)
@@ -352,17 +352,17 @@
 		.Add(new BScrollView("activity scroll", fActivityChart, 0, true, false))
 		.AddStrut(20)
 		.Add(BGridLayoutBuilder()
-			.Add(fRunTimeCheckBox = new ColorCheckBox("Run Time", kRunTimeColor,
+			.Add(fRunTimeCheckBox = new ColorCheckBox("Run time", kRunTimeColor,
 					new BMessage(MSG_CHECK_BOX_RUN_TIME)),
 				0, 0)
-			.Add(fWaitTimeCheckBox = new ColorCheckBox("Wait Time",
+			.Add(fWaitTimeCheckBox = new ColorCheckBox("Wait time",
 					kWaitTimeColor, new BMessage(MSG_CHECK_BOX_WAIT_TIME)),
 				1, 0)
-			.Add(fPreemptionTimeCheckBox = new ColorCheckBox("Preemption Time",
+			.Add(fPreemptionTimeCheckBox = new ColorCheckBox("Preemption time",
 					kPreemptionTimeColor,
 					new BMessage(MSG_CHECK_BOX_PREEMPTION_TIME)),
 				0, 1)
-			.Add(fLatencyTimeCheckBox = new ColorCheckBox("Latency Time",
+			.Add(fLatencyTimeCheckBox = new ColorCheckBox("Latency time",
 					kLatencyTimeColor,
 					new BMessage(MSG_CHECK_BOX_LATENCY_TIME)),
 				1, 1)
Index: src/apps/debuganalyzer/gui/thread_window/GeneralPage.cpp
===================================================================
--- src/apps/debuganalyzer/gui/thread_window/GeneralPage.cpp	(Revision 34761)
+++ src/apps/debuganalyzer/gui/thread_window/GeneralPage.cpp	(Arbeitskopie)
@@ -27,11 +27,11 @@
 	fThreadNameView = AddDataView("Name:");
 	fThreadIDView = AddDataView("ID:");
 	fTeamView = AddDataView("Team:");
-	fRunTimeView = AddDataView("Run Time:");
-	fWaitTimeView = AddDataView("Wait Time:");
+	fRunTimeView = AddDataView("Run time:");
+	fWaitTimeView = AddDataView("Wait time:");
 	fLatencyView = AddDataView("Latencies:");
 	fPreemptionView = AddDataView("Preemptions:");
-	fUnspecifiedTimeView = AddDataView("Unspecified Time:");
+	fUnspecifiedTimeView = AddDataView("Unspecified time:");
 }
 
 
Index: src/apps/debuganalyzer/gui/main_window/SchedulingPage.cpp
===================================================================
--- src/apps/debuganalyzer/gui/main_window/SchedulingPage.cpp	(Revision 34761)
+++ src/apps/debuganalyzer/gui/main_window/SchedulingPage.cpp	(Arbeitskopie)
@@ -478,21 +478,21 @@
 			int32 filteredCount = fFilterModel->CountSelectedItems();
 			int32 selectedCount = fSelectionModel->CountSelectedItems();
 
-			BMenuItem* item = new BMenuItem("Hide Selected Threads",
+			BMenuItem* item = new BMenuItem("Hide selected threads",
 				new BMessage(MSG_SCHEDULING_FILTER_HIDE_SELECTED));
 			contextMenu->AddItem(item);
 			item->SetTarget(this);
 			if (selectedCount == 0 || selectedCount == filteredCount)
 				item->SetEnabled(false);
 
-			item = new BMenuItem("Hide Unselected Threads",
+			item = new BMenuItem("Hide unselected threads",
 				new BMessage(MSG_SCHEDULING_FILTER_HIDE_UNSELECTED));
 			contextMenu->AddItem(item);
 			item->SetTarget(this);
 			if (selectedCount == 0 || selectedCount == filteredCount)
 				item->SetEnabled(false);
 
-			item = new BMenuItem("Show All Threads",
+			item = new BMenuItem("Show all threads",
 				new BMessage(MSG_SCHEDULING_FILTER_SHOW_ALL));
 			contextMenu->AddItem(item);
 			item->SetTarget(this);
@@ -899,7 +899,7 @@
 		}
 
 		text << "\n\n";
-		text << "Running Threads:";
+		text << "Running threads:";
 		for (int32 i = 0; i < cpuCount; i++) {
 			text << "\n  " << i << ": ";
 			if (Model::Thread* thread = runningThreads[i])
Index: src/apps/debuganalyzer/gui/main_window/ThreadsPage.cpp
===================================================================
--- src/apps/debuganalyzer/gui/main_window/ThreadsPage.cpp	(Revision 34761)
+++ src/apps/debuganalyzer/gui/main_window/ThreadsPage.cpp	(Arbeitskopie)
@@ -133,21 +133,21 @@
 		1000, false, B_TRUNCATE_MIDDLE, B_ALIGN_RIGHT));
 	fThreadsTable->AddColumn(new Int64TableColumn(5, "Runs", 80, 20, 1000,
 		B_TRUNCATE_END, B_ALIGN_RIGHT));
-	fThreadsTable->AddColumn(new NanotimeTableColumn(6, "Run Time", 80, 20,
+	fThreadsTable->AddColumn(new NanotimeTableColumn(6, "Run time", 80, 20,
 		1000, false, B_TRUNCATE_END, B_ALIGN_RIGHT));
 	fThreadsTable->AddColumn(new Int64TableColumn(7, "Latencies", 80, 20, 1000,
 		B_TRUNCATE_END, B_ALIGN_RIGHT));
-	fThreadsTable->AddColumn(new NanotimeTableColumn(8, "Latency Time", 80, 20,
+	fThreadsTable->AddColumn(new NanotimeTableColumn(8, "Latency time", 80, 20,
 		1000, B_TRUNCATE_END, B_ALIGN_RIGHT));
 	fThreadsTable->AddColumn(new Int64TableColumn(9, "Preemptions", 80, 20,
 		1000, B_TRUNCATE_END, B_ALIGN_RIGHT));
-	fThreadsTable->AddColumn(new NanotimeTableColumn(10, "Preemption Time", 80,
+	fThreadsTable->AddColumn(new NanotimeTableColumn(10, "Preemption time", 80,
 		20, 1000, false, B_TRUNCATE_END, B_ALIGN_RIGHT));
 	fThreadsTable->AddColumn(new Int64TableColumn(11, "Waits", 80, 20,
 		1000, B_TRUNCATE_END, B_ALIGN_RIGHT));
-	fThreadsTable->AddColumn(new NanotimeTableColumn(12, "Wait Time", 80,
+	fThreadsTable->AddColumn(new NanotimeTableColumn(12, "Wait time", 80,
 		20, 1000, false, B_TRUNCATE_END, B_ALIGN_RIGHT));
-	fThreadsTable->AddColumn(new NanotimeTableColumn(13, "Unspecified Time", 80,
+	fThreadsTable->AddColumn(new NanotimeTableColumn(13, "Unspecified time", 80,
 		20, 1000, false, B_TRUNCATE_END, B_ALIGN_RIGHT));
 	fThreadsTable->AddColumn(new Int64TableColumn(14, "I/O Count", 80, 20,
 		1000, B_TRUNCATE_END, B_ALIGN_RIGHT));
Index: src/apps/debuganalyzer/gui/main_window/GeneralPage.cpp
===================================================================
--- src/apps/debuganalyzer/gui/main_window/GeneralPage.cpp	(Revision 34761)
+++ src/apps/debuganalyzer/gui/main_window/GeneralPage.cpp	(Arbeitskopie)
@@ -21,10 +21,10 @@
 	fTeamCountView(NULL),
 	fThreadCountView(NULL)
 {
-	fDataSourceView = AddDataView("Data Source:");
+	fDataSourceView = AddDataView("Data source:");
 	fCPUCountView = AddDataView("Number of CPUs:");
-	fRunTimeView = AddDataView("Total Time:");
-	fIdleTimeView = AddDataView("Idle Time:");
+	fRunTimeView = AddDataView("Total time:");
+	fIdleTimeView = AddDataView("Idle time:");
 	fTeamCountView = AddDataView("Teams:");
 	fThreadCountView = AddDataView("Threads:");
 }