Index: build/jam/HaikuImage
===================================================================
--- build/jam/HaikuImage	(Revision 34761)
+++ build/jam/HaikuImage	(Arbeitskopie)
@@ -317,13 +317,13 @@
 		: /boot/system/apps/$(linkTarget) : $(linkTarget) ;
 }
 
-# Deskbar Desktop Applets links
-AddDirectoryToHaikuImage home config be Desktop\ Applets ;
+# Deskbar Desktop applets links
+AddDirectoryToHaikuImage home config be Desktop\ applets ;
 DESKBAR_DESKTOP_APPLETS = LaunchBox NetworkStatus PowerStatus ProcessController
 	Workspaces
 ;
 for linkTarget in $(DESKBAR_DESKTOP_APPLETS) {
-	AddSymlinkToHaikuImage home config be Desktop\ Applets
+	AddSymlinkToHaikuImage home config be Desktop\ applets
 		: /boot/system/apps/$(linkTarget) : $(linkTarget) ;
 }
 
Index: build/jam/OptionalPackages
===================================================================
--- build/jam/OptionalPackages	(Revision 34761)
+++ build/jam/OptionalPackages	(Arbeitskopie)
@@ -520,7 +520,7 @@
 			: $(baseURL)/KeymapSwitcher-1.2.3-x86-gcc4-2009-05-31.zip
 			:
 		;
-		AddSymlinkToHaikuImage home config be Desktop\ Applets
+		AddSymlinkToHaikuImage home config be Desktop\ applets
 			: /boot/common/bin/KeymapSwitcher ;
 	} else {
 		InstallOptionalHaikuImagePackage
@@ -528,7 +528,7 @@
 			: $(baseURL)/KeymapSwitcher-1.2.4-r1a1-x86-gcc2-2009-09-06.zip
 			:
 		;
-		AddSymlinkToHaikuImage home config be Desktop\ Applets
+		AddSymlinkToHaikuImage home config be Desktop\ applets
 			: /boot/common/bin/KeymapSwitcher ;
 	}
 }

Index: /HiQ-Data/source/haiku/trunk/src/documentation/uiguidelines/HaikuHIG.xml
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/documentation/uiguidelines/HaikuHIG.xml    (revision 34753)
+++ /HiQ-Data/source/haiku/trunk/src/documentation/uiguidelines/HaikuHIG.xml    (working copy)
@@ -459,7 +459,7 @@
 <sect1>
 <title>Capitalization and Spelling</title>
 
-<para>Nothing is more unprofessional than spelling and capitalization errors. If spelling is not your strong suit, consult a spell checker, dictionary, or at least a friend. This is particularly important if you are working with a language which is not your native one. Use title capitalization in all places except where full sentences are used. This means that all "important" words and the last word in a phrase -- regardless of importance -- are capitalized. Prepositions, definite articles, and conjunctions (as, for, to, the, and, etc.) are generally not capitalized except when they are the first or last word in the phrase, such as in "Save As...".</para>
+<para>Nothing is more unprofessional than spelling and capitalization errors. If spelling is not your strong suit, consult a spell checker, dictionary, or at least a friend. This is particularly important if you are working with a language which is not your native one. Use sentence capitalization in all places, that is, follow the normal grammar rules of the language. For English, this means only to capitalize specific names like "Tracker" or "Deskbar".</para>
 
 </sect1>
 <sect1>

Index: src/tests/add-ons/kernel/file_systems/userlandfs/r5/src/test/netfs/authentication_server/AuthenticationPanel.cpp
===================================================================
--- src/tests/add-ons/kernel/file_systems/userlandfs/r5/src/test/netfs/authentication_server/AuthenticationPanel.cpp	(Revision 34761)
+++ src/tests/add-ons/kernel/file_systems/userlandfs/r5/src/test/netfs/authentication_server/AuthenticationPanel.cpp	(Arbeitskopie)
@@ -42,7 +42,7 @@
 								 NULL, B_FOLLOW_LEFT | B_FOLLOW_RIGHT);
 
 	BRect buttonFrame(0.0, 0.0, 20.0, 15.0);
-	fOkB = new BButton(buttonFrame, "ok", "Ok",
+	fOkB = new BButton(buttonFrame, "ok", "OK",
 					   new BMessage(MSG_PANEL_OK));
 	fCancelB = new BButton(buttonFrame, "cancel", "Cancel",
 						   new BMessage(MSG_PANEL_CANCEL));
Index: src/tests/servers/app/look_and_feel/LookAndFeel.cpp
===================================================================
--- src/tests/servers/app/look_and_feel/LookAndFeel.cpp	(Revision 34761)
+++ src/tests/servers/app/look_and_feel/LookAndFeel.cpp	(Arbeitskopie)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2005, Haiku Inc.
+ * Copyright 2005-2009, Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -295,7 +295,7 @@
 					char text[512];
 					snprintf(text, sizeof(text),
 						"Window could not be added to subset:\n\n\%s", strerror(status));
-					(new BAlert("Alert", text, "Ok"))->Go(NULL);
+					(new BAlert("Alert", text, "OK"))->Go(NULL);
 
 					delete window;
 					break;
Index: src/tests/kits/interface/look/Look.cpp
===================================================================
--- src/tests/kits/interface/look/Look.cpp	(Revision 34761)
+++ src/tests/kits/interface/look/Look.cpp	(Arbeitskopie)
@@ -93,8 +93,8 @@
 void
 add_text_controls(BGridLayout* layout, int32& row)
 {
-	BTextControl* control1 = new BTextControl("Enabled", "Some Text", NULL);
-	BTextControl* control2 = new BTextControl("Disabled", "More Text", NULL);
+	BTextControl* control1 = new BTextControl("Enabled", "Some text", NULL);
+	BTextControl* control2 = new BTextControl("Disabled", "More text", NULL);
 	control2->SetEnabled(false);
 
 #if USE_LAYOUT_ITEMS
@@ -270,7 +270,7 @@
 	// BListView
 	BListView* listView = new BListView();
 	for (int32 i = 0; i < 20; i++) {
-		BString itemLabel("List Item ");
+		BString itemLabel("List item ");
 		itemLabel << i + 1;
 		listView->AddItem(new BStringItem(itemLabel.String()));
 	}
@@ -327,7 +327,7 @@
 	menu->AddItem(new BMenuItem("Test Save BFilePanel",
 		new BMessage(MSG_TEST_SAVE_FILE_PANEL)));
 	menu->AddItem(new BMenuItem("Click me!", NULL));
-	menu->AddItem(new BMenuItem("Another Option", NULL));
+	menu->AddItem(new BMenuItem("Another option", NULL));
 	menu->AddSeparatorItem();
 	menu->AddItem(new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED)));
 	menuBar->AddItem(menu);
@@ -342,14 +342,14 @@
 	menu->AddItem(new BMenuItem("Only", NULL));
 	menuBar->AddItem(menu);
 	menu = new BMenu("Sub Menu");
-	BMenu* subMenu = new BMenu("Click Me");
+	BMenu* subMenu = new BMenu("Click me");
 	subMenu->AddItem(new BMenuItem("Either", NULL));
 	subMenu->AddItem(new BMenuItem("Or", NULL));
 	subMenu->SetRadioMode(true);
 	menu->AddItem(subMenu);
 	menuBar->AddItem(menu);
 
-	BButton* okButton = new BButton("Ok", new BMessage(B_QUIT_REQUESTED));
+	BButton* okButton = new BButton("OK", new BMessage(B_QUIT_REQUESTED));
 
 	window->AddChild(BGroupLayoutBuilder(B_VERTICAL)
 		.Add(menuBar)
Index: src/tests/kits/net/preflet/InterfacesAddOn/EthernetSettingsView.cpp
===================================================================
--- src/tests/kits/net/preflet/InterfacesAddOn/EthernetSettingsView.cpp	(Revision 34761)
+++ src/tests/kits/net/preflet/InterfacesAddOn/EthernetSettingsView.cpp	(Arbeitskopie)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2004-2008 Haiku Inc. All rights reserved.
+ * Copyright 2004-2009 Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -340,7 +340,7 @@
 	BMessenger networkServer(kNetServerSignature);
 	if (!networkServer.IsValid()) {
 		(new BAlert("error", "The net_server needs to run for the auto "
-			"configuration!", "Ok"))->Go();
+			"configuration!", "OK"))->Go();
 		return B_ERROR;
 	}
 
@@ -356,13 +356,13 @@
 	if (status != B_OK) {
 		BString errorMessage("Sending auto-config message failed: ");
 		errorMessage << strerror(status);
-		(new BAlert("error", errorMessage.String(), "Ok"))->Go();
+		(new BAlert("error", errorMessage.String(), "OK"))->Go();
 		return status;
 	} else if (reply.FindInt32("status", &status) == B_OK
 			&& status != B_OK) {
 		BString errorMessage("Auto-configuring failed: ");
 		errorMessage << strerror(status);
-		(new BAlert("error", errorMessage.String(), "Ok"))->Go();
+		(new BAlert("error", errorMessage.String(), "OK"))->Go();
 		return status;
 	}
 
Index: src/tests/kits/game/file_game_sound_test/FileSoundWindow.cpp
===================================================================
--- src/tests/kits/game/file_game_sound_test/FileSoundWindow.cpp	(Revision 34761)
+++ src/tests/kits/game/file_game_sound_test/FileSoundWindow.cpp	(Arbeitskopie)
@@ -34,7 +34,7 @@
 	BBox *box = new BBox(appBounds);
 	//textcontrol to display the chosen file
 	BRect textBounds(appBounds.left + 10, appBounds.top + 10, appBounds.right - 70, appBounds.top + 20);
-	textControl = new BTextControl(textBounds,"filechosen","Play File:","No file chosen yet.", NULL);
+	textControl = new BTextControl(textBounds,"filechosen","Play file:","No file chosen yet.", NULL);
 	textControl -> SetEnabled(false);
 	
 	float x1 = textControl -> Bounds().left;
@@ -110,17 +110,17 @@
 					fileSound = 0;
 					if (error == B_NO_MEMORY)
 					{
-						BAlert *alert = new BAlert("alert","Not enough memory.","Ok");
+						BAlert *alert = new BAlert("alert","Not enough memory.","OK");
 						alert -> Go();
 					}
 					else if (error == B_ERROR)
 					{
-						BAlert *alert = new BAlert("alert","Unable to create a sound player.","Ok");
+						BAlert *alert = new BAlert("alert","Unable to create a sound player.","OK");
 						alert -> Go();
 					}
 					else
 					{
-						BAlert *alert = new BAlert("alert","Other kind of error!","Ok");
+						BAlert *alert = new BAlert("alert","Other kind of error!","OK");
 						alert -> Go();
 					}				
 					break;
@@ -133,7 +133,7 @@
 					status_t preloadError = fileSound -> Preload();
 					if (preloadError != B_OK)
 					{
-						BAlert *alert = new BAlert("alert","Port errors. Unable to communicate with the streaming sound port.","Ok");
+						BAlert *alert = new BAlert("alert","Port errors. Unable to communicate with the streaming sound port.","OK");
 						alert -> Go();
 					}
 				}	
@@ -143,12 +143,12 @@
 				{
 					if (playerror == EALREADY)
 					{
-						BAlert *alert = new BAlert("alert","Sound is already playing","Ok");
+						BAlert *alert = new BAlert("alert","Sound is already playing","OK");
 						alert -> Go();
 					}
 					else
 					{
-						BAlert *alert = new BAlert("alert","Error playing sound","Ok");
+						BAlert *alert = new BAlert("alert","Error playing sound","OK");
 						alert -> Go();
 					}
 				}
@@ -166,12 +166,12 @@
 				{
 					if (stoperror == EALREADY)
 					{
-						BAlert *alert = new BAlert("alert","Sound is already stopped","Ok");
+						BAlert *alert = new BAlert("alert","Sound is already stopped","OK");
 						alert -> Go();
 					}
 					else
 					{
-						BAlert *alert = new BAlert("alert","Error stopping sound","Ok");
+						BAlert *alert = new BAlert("alert","Error stopping sound","OK");
 						alert -> Go();
 					}
 				}
@@ -213,12 +213,12 @@
 				{
 					if (error == EALREADY)
 					{
-						BAlert *alert = new BAlert("alert","Already in requested state","Ok");
+						BAlert *alert = new BAlert("alert","Already in requested state","OK");
 						alert -> Go();
 					}
 					else
 					{
-						BAlert *alert = new BAlert("alert","Error!","Ok");
+						BAlert *alert = new BAlert("alert","Error!","OK");
 						alert -> Go();
 					}
 				} 
Index: src/tests/kits/game/chart/ChartWindow.cpp
===================================================================
--- src/tests/kits/game/chart/ChartWindow.cpp	(Revision 34761)
+++ src/tests/kits/game/chart/ChartWindow.cpp	(Arbeitskopie)
@@ -5,6 +5,7 @@
 	by Pierre Raynaud-Richard.
 
 	Copyright 1998 Be Incorporated, All Rights Reserved.
+	Copyright 2009, Haiku, Inc. All rights reserved.
 
 */
 
@@ -679,7 +680,7 @@
 
 		/* Fullscreen mode check box */
 		r.Set(h, v, h+LEFT_WIDTH-2*LEFT_OFFSET-1, v+FULL_SCREEN-1);
-		full_screen = new BCheckBox(r, "", "Full Screen", new BMessage(FULL_SCREEN_MSG));
+		full_screen = new BCheckBox(r, "", "Full screen", new BMessage(FULL_SCREEN_MSG));
 		full_screen->SetTarget(this);
 		full_screen->SetFont(&font);
 		full_screen->ResizeToPreferred();
@@ -708,7 +709,7 @@
 
 		/* Enabling second thread check box */
 		r.Set(h, v, h+LEFT_WIDTH-2*LEFT_OFFSET-1, v+SECOND_THREAD-1);
-		check_box = new BCheckBox(r, "", "2 Threads", new BMessage(SECOND_THREAD_MSG));
+		check_box = new BCheckBox(r, "", "2 threads", new BMessage(SECOND_THREAD_MSG));
 		check_box->SetTarget(this);
 		check_box->SetFont(&font);
 		check_box->ResizeToPreferred();

Index: src/bin/network/ppp_up/PPPStatusView.cpp
===================================================================
--- src/bin/network/ppp_up/PPPStatusView.cpp	(Revision 34761)
+++ src/bin/network/ppp_up/PPPStatusView.cpp	(Arbeitskopie)
@@ -1,5 +1,6 @@
 /*
  * Copyright 2005, Waldemar Kornewald <wkornew@gmx.net>
+ * Copyright 2009, Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  */
 
@@ -21,7 +22,7 @@
 
 // labels
 static const char *kLabelDisconnect = "Disconnect";
-static const char *kLabelConnectedSince = "Connected Since: ";
+static const char *kLabelConnectedSince = "Connected since: ";
 static const char *kLabelReceived = "Received";
 static const char *kLabelSent = "Sent";
 
Index: src/bin/network/ppp_up/ConnectionView.cpp
===================================================================
--- src/bin/network/ppp_up/ConnectionView.cpp	(Revision 34761)
+++ src/bin/network/ppp_up/ConnectionView.cpp	(Arbeitskopie)
@@ -1,5 +1,6 @@
 /*
  * Copyright 2005, Waldemar Kornewald <wkornew@gmx.net>
+ * Copyright 2009, Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  */
 
@@ -34,7 +35,7 @@
 static const uint32 kMsgUpdate = 'MUPD';
 
 // labels
-static const char *kLabelSavePassword = "Save Password";
+static const char *kLabelSavePassword = "Save password";
 static const char *kLabelName = "Username: ";
 static const char *kLabelPassword = "Password: ";
 static const char *kLabelConnect = "Connect";
Index: src/bin/desklink/MediaReplicant.cpp
===================================================================
--- src/bin/desklink/MediaReplicant.cpp	(Revision 34761)
+++ src/bin/desklink/MediaReplicant.cpp	(Arbeitskopie)
@@ -219,9 +219,9 @@
 		BPopUpMenu* menu = new BPopUpMenu("", false, false);
 		menu->SetFont(be_plain_font);
 
-		menu->AddItem(new BMenuItem("Media Preferences" B_UTF8_ELLIPSIS,
+		menu->AddItem(new BMenuItem("Media preferences" B_UTF8_ELLIPSIS,
 			new BMessage(kMsgOpenMediaSettings)));
-		menu->AddItem(new BMenuItem("Sound Preferences" B_UTF8_ELLIPSIS,
+		menu->AddItem(new BMenuItem("Sound preferences" B_UTF8_ELLIPSIS,
 			new BMessage(kMsgOpenSoundSettings)));
 
 		menu->AddSeparatorItem();
@@ -234,7 +234,7 @@
 		BMenu* subMenu = new BMenu("Options");
 		menu->AddItem(subMenu);
 
-		BMenuItem* item = new BMenuItem("Control Physical Output",
+		BMenuItem* item = new BMenuItem("Control physical output",
 			new BMessage(kMsgVolumeWhich));
 		item->SetMarked(fVolumeWhich == VOLUME_USE_PHYS_OUTPUT);
 		subMenu->AddItem(item);
Index: src/bin/mail_utils/spamdbm.cpp
===================================================================
--- src/bin/mail_utils/spamdbm.cpp	(Revision 34761)
+++ src/bin/mail_utils/spamdbm.cpp	(Arbeitskopie)
@@ -888,13 +888,13 @@
 static char * g_TokenizeModeNames [TM_MAX] =
 {
   "All",
-  "Plain Text",
-  "Plain Text and Header",
-  "Any Text",
-  "Any Text and Header",
-  "All Parts",
-  "All Parts and Header",
-  "Just Header"
+  "Plain text",
+  "Plain text and header",
+  "Any text",
+  "Any text and header",
+  "All parts",
+  "All parts and header",
+  "Just header"
 };
 
 
@@ -6369,7 +6369,7 @@
         break;
 
       case TM_ANY_TEXT_HEADER:
-        strcat (TempString, " - Scan entire e-mail text and text attachments (Recommended)");
+       strcat (TempString, " - Scan entire e-mail text and text attachments (recommended)");
         break;
 
       case TM_ALL_PARTS:
@@ -6448,11 +6448,11 @@
     switch (ScoringMode)
     {
       case SM_ROBINSON:
-        strcpy (TempString, "Learning Method 1: Naive Bayesian");
+        strcpy (TempString, "Learning method 1: Naive Bayesian");
         break;
 
       case SM_CHISQUARED:
-        strcpy (TempString, "Learning Method 2: Chi-Squared");
+        strcpy (TempString, "Learning method 2: Chi-Squared");
         break;
 
       default:
@@ -6483,7 +6483,7 @@
   CommandMessage.what = B_EXECUTE_PROPERTY;
   CommandMessage.AddSpecifier (g_PropertyNames[PN_INSTALL_THINGS]);
   m_InstallThingsButtonPntr = new BButton (TempRect, "Install Button",
-    "Install Spam Types",
+    "Install spam types",
     new BMessage (CommandMessage),
     B_FOLLOW_LEFT | B_FOLLOW_TOP);
   if (m_InstallThingsButtonPntr == NULL) goto ErrorExit;
@@ -6502,7 +6502,7 @@
   CommandMessage.what = B_EXECUTE_PROPERTY;
   CommandMessage.AddSpecifier (g_PropertyNames[PN_RESET_TO_DEFAULTS]);
   m_ResetToDefaultsButtonPntr = new BButton (TempRect, "Reset Button",
-    "Default Settings", new BMessage (CommandMessage),
+    "Default settings", new BMessage (CommandMessage),
     B_FOLLOW_RIGHT | B_FOLLOW_TOP);
   if (m_ResetToDefaultsButtonPntr == NULL) goto ErrorExit;
   AddChild (m_ResetToDefaultsButtonPntr);
@@ -6525,7 +6525,7 @@
   TempRect.left = X;
 
   m_EstimateSpamButtonPntr = new BButton (TempRect, "Estimate Button",
-    "Scan a Message",
+    "Scan a message",
     new BMessage (MSG_ESTIMATE_BUTTON),
     B_FOLLOW_LEFT | B_FOLLOW_TOP);
   if (m_EstimateSpamButtonPntr == NULL) goto ErrorExit;
@@ -6543,7 +6543,7 @@
   TempRect.left = X;
 
   m_AddExampleButtonPntr = new BButton (TempRect, "Example Button",
-    "Train Spam Filter on a Message",
+    "Train spam filter on a message",
     new BMessage (MSG_BROWSE_BUTTON),
     B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,
     B_WILL_DRAW | B_NAVIGABLE | B_FULL_UPDATE_ON_RESIZE);
@@ -6577,7 +6577,7 @@
   RowHeight = g_TextBoxHeight;
   RowHeight = ceilf (RowHeight * 1.1);
 
-  StringPntr = "Genuine Messages:";
+  StringPntr = "Genuine messages:";
   m_GenuineCountCachedValue = 87654321;
   sprintf (TempString, "%d", (int) m_GenuineCountCachedValue);
 
@@ -6591,7 +6591,7 @@
     3 * g_MarginBetweenControls;
 
   m_GenuineCountTextboxPntr = new BTextControl (TempRect,
-    "Genuine Count",
+    "Genuine count",
     StringPntr /* label */,
     TempString /* text */,
     NULL /* no message */,
@@ -6605,7 +6605,7 @@
 
   /* The word count in the center. */
 
-  StringPntr = "Word Count:";
+  StringPntr = "Word count:";
   m_WordCountCachedValue = 87654321;
   sprintf (TempString, "%d", (int) m_WordCountCachedValue);
 
@@ -6620,7 +6620,7 @@
   TempRect.right = TempRect.left + Width;
 
   m_WordCountTextboxPntr = new BTextControl (TempRect,
-    "Word Count",
+    "Word count",
     StringPntr /* label */,
     TempString /* text */,
     NULL /* no message */,
@@ -6634,7 +6634,7 @@
 
   /* The spam count on the far right. */
 
-  StringPntr = "Spam Messages:";
+  StringPntr = "Spam messages:";
   m_SpamCountCachedValue = 87654321;
   sprintf (TempString, "%d", (int) m_SpamCountCachedValue);
 
@@ -6648,7 +6648,7 @@
     3 * g_MarginBetweenControls;
 
   m_SpamCountTextboxPntr = new BTextControl (TempRect,
-    "Spam Count",
+    "Spam count",
     StringPntr /* label */,
     TempString /* text */,
     NULL /* no message */,
@@ -7035,7 +7035,7 @@
 
 DatabaseWindow::DatabaseWindow ()
 : BWindow (BRect (30, 30, 620, 400),
-    "Haiku Spam Filter Server",
+    "Haiku spam filter server",
     B_DOCUMENT_WINDOW, B_ASYNCHRONOUS_CONTROLS)
 {
   BRect TempRect;
Index: src/bin/mail_utils/mail2mbox.cpp
===================================================================
--- src/bin/mail_utils/mail2mbox.cpp	(Revision 34761)
+++ src/bin/mail_utils/mail2mbox.cpp	(Arbeitskopie)
@@ -302,7 +302,7 @@
 	BApplication app("application/x-vnd.Haiku-mail2mbox");
 
 	if (argc <= 1 || argc >= 3) {
-		printf("%s is a utility for converting BeMail e-mail\n", argv[0]);
+		printf("%s is a utility for converting Mail e-mail\n", argv[0]);
 		printf("files to Unix Pine style e-mail files.  It could well\n");
 		printf("work with other Unix style mailbox files.  Each message in\n");
 		printf("the input directory is converted and sent to the standard\n");
Index: src/bin/mail_utils/mbox2mail.cpp
===================================================================
--- src/bin/mail_utils/mbox2mail.cpp	(Revision 34761)
+++ src/bin/mail_utils/mbox2mail.cpp	(Arbeitskopie)
@@ -516,7 +516,7 @@
   {
     printf ("%s is a utility for converting Pine e-mail\n",
       argv[0]);
-    printf ("files (mbox files) to BeOS e-mail files with attributes.  It\n");
+    printf ("files (mbox files) to Mail e-mail files with attributes.  It\n");
     printf ("could well work with other Unix style mailbox files, and\n");
     printf ("saved Usenet article files.  Each message in the input\n");
     printf ("mailbox is converted into a separate file.  You can\n");
Index: src/bin/screen_blanker/PasswordWindow.cpp
===================================================================
--- src/bin/screen_blanker/PasswordWindow.cpp	(Revision 34761)
+++ src/bin/screen_blanker/PasswordWindow.cpp	(Arbeitskopie)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2003-2008, Haiku, Inc. All Rights Reserved.
+ * Copyright 2003-2009, Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -20,7 +20,7 @@
 
 
 PasswordWindow::PasswordWindow()
-	: BWindow(BRect(100, 100, 400, 230), "Enter Password",
+	: BWindow(BRect(100, 100, 400, 230), "Enter password",
 		B_NO_BORDER_WINDOW_LOOK, kPasswordWindowFeel
 			/* TODO: B_MODAL_APP_WINDOW_FEEL should also behave correctly */,
 		B_NOT_MOVABLE | B_NOT_CLOSABLE | B_NOT_ZOOMABLE | B_NOT_MINIMIZABLE
Index: src/data/beos_mime/image/x-pcx
===================================================================
--- src/data/beos_mime/image/x-pcx	(Revision 34761)
+++ src/data/beos_mime/image/x-pcx	(Arbeitskopie)
@@ -5,9 +5,9 @@
 resource(2, "META:SNIFF_RULE") "0.5 (\"\\012\\005\\001\") [3](0x01 | 0x04 | 0x08)";
 	// version 5, encoding 1 is all our translator currently supports
 
-resource(3, "META:S:DESC") #'MSDC' "PCX Image";
+resource(3, "META:S:DESC") #'MSDC' "PCX image";
 
-resource(4, "META:L:DESC") #'MLDC' "PC Paintbrush Image";
+resource(4, "META:L:DESC") #'MLDC' "PC Paintbrush image";
 
 resource(5, "META:EXTENS") message(234) {
 	"extensions" = "pcx",
Index: src/data/beos_mime/image/sgi
===================================================================
--- src/data/beos_mime/image/sgi	(Revision 34761)
+++ src/data/beos_mime/image/sgi	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"\\001\\332\")";
 
-resource(3, "META:S:DESC") #'MSDC' "SGI Image";
+resource(3, "META:S:DESC") #'MSDC' "SGI image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "sgi",
Index: src/data/beos_mime/image/vnd.microsoft.icon
===================================================================
--- src/data/beos_mime/image/vnd.microsoft.icon	(Revision 34761)
+++ src/data/beos_mime/image/vnd.microsoft.icon	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"\\000\\000\\001\\000\" | \"\\000\\000\\002\\000\")";
 
-resource(3, "META:S:DESC") #'MSDC' "Windows Icon";
+resource(3, "META:S:DESC") #'MSDC' "Windows icon";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "ico",
Index: src/data/beos_mime/image/x-targa
===================================================================
--- src/data/beos_mime/image/x-targa	(Revision 34761)
+++ src/data/beos_mime/image/x-targa	(Arbeitskopie)
@@ -2,7 +2,7 @@
 
 resource(1, "META:TYPE") "image/x-targa";
 
-resource(2, "META:S:DESC") #'MSDC' "Targa Image";
+resource(2, "META:S:DESC") #'MSDC' "Targa image";
 
 resource(3, "META:EXTENS") message(234) {
 	"extensions" = "tga",
Index: src/data/beos_mime/image/png
===================================================================
--- src/data/beos_mime/image/png	(Revision 34761)
+++ src/data/beos_mime/image/png	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.70 (\"\\211PNG\\015\\012\\032\\012\")";
 
-resource(3, "META:S:DESC") #'MSDC' "PNG Image";
+resource(3, "META:S:DESC") #'MSDC' "PNG image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "png",
Index: src/data/beos_mime/image/gif
===================================================================
--- src/data/beos_mime/image/gif	(Revision 34761)
+++ src/data/beos_mime/image/gif	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.70 (\"GIF8\")";
 
-resource(3, "META:S:DESC") #'MSDC' "GIF Image";
+resource(3, "META:S:DESC") #'MSDC' "GIF image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "gif",
Index: src/data/beos_mime/image/jpeg
===================================================================
--- src/data/beos_mime/image/jpeg	(Revision 34761)
+++ src/data/beos_mime/image/jpeg	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"\\377\\330\\377\")";
 
-resource(3, "META:S:DESC") #'MSDC' "JPEG Image";
+resource(3, "META:S:DESC") #'MSDC' "JPEG image";
 
 resource(5, "META:EXTENS") message(234) {
 	"extensions" = "jpeg",
Index: src/data/beos_mime/image/tiff
===================================================================
--- src/data/beos_mime/image/tiff	(Revision 34761)
+++ src/data/beos_mime/image/tiff	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"MM\\000\\052\" | \"II\\052\\000\" | \"IIN1\")";
 
-resource(3, "META:S:DESC") #'MSDC' "TIFF Image";
+resource(3, "META:S:DESC") #'MSDC' "TIFF image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "tif",
Index: src/data/beos_mime/image/x-portable-pixmap
===================================================================
--- src/data/beos_mime/image/x-portable-pixmap	(Revision 34761)
+++ src/data/beos_mime/image/x-portable-pixmap	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"P6\")";
 
-resource(3, "META:S:DESC") #'MSDC' "PPM Image";
+resource(3, "META:S:DESC") #'MSDC' "PPM image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "ppm",
Index: src/data/beos_mime/image/jp2
===================================================================
--- src/data/beos_mime/image/jp2	(Revision 34761)
+++ src/data/beos_mime/image/jp2	(Arbeitskopie)
@@ -3,7 +3,7 @@
 
 resource(1, "META:TYPE") "image/jp2";
 
-resource(2, "META:S:DESC") #'MSDC' "JPEG2000 Image";
+resource(2, "META:S:DESC") #'MSDC' "JPEG2000 image";
 
 resource(3, "META:EXTENS") message(234) {
 	"extensions" = "jp2",
Index: src/data/beos_mime/image/svg+xml
===================================================================
--- src/data/beos_mime/image/svg+xml	(Revision 34761)
+++ src/data/beos_mime/image/svg+xml	(Arbeitskopie)
@@ -3,7 +3,7 @@
 
 resource(1, "META:TYPE") "image/svg+xml";
 
-resource(2, "META:S:DESC") #'MSDC' "SVG Image";
+resource(2, "META:S:DESC") #'MSDC' "SVG image";
 
 resource(3, "META:EXTENS") message(234) {
 	"extensions" = "svg",
Index: src/data/beos_mime/image/bmp
===================================================================
--- src/data/beos_mime/image/bmp	(Revision 34761)
+++ src/data/beos_mime/image/bmp	(Arbeitskopie)
@@ -5,7 +5,7 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"BM\")";
 
-resource(3, "META:S:DESC") #'MSDC' "BMP Image";
+resource(3, "META:S:DESC") #'MSDC' "BMP image";
 
 resource(4, "META:EXTENS") message(234) {
 	"extensions" = "bmp",

Index: data/image_directories/home-config-settings-printers-save-as-pdf.rdef
===================================================================
--- data/image_directories/home-config-settings-printers-save-as-pdf.rdef	(Revision 34761)
+++ data/image_directories/home-config-settings-printers-save-as-pdf.rdef	(Arbeitskopie)
@@ -3,7 +3,7 @@
 
 resource(1, "Printer Name") "Save as PDF";
 resource(2, "Driver Name") "PDF Writer";
-resource(3, "transport") "Print To File";
+resource(3, "transport") "Print to file";
 resource(4, "transport_address") "";
 resource(5, "connection") "Local";
 resource(6, "state") "free";

Index: headers/private/media/MediaSounds.h
===================================================================
--- headers/private/media/MediaSounds.h	(Revision 34761)
+++ headers/private/media/MediaSounds.h	(Arbeitskopie)
@@ -1,5 +1,5 @@
 /* 
- * Copyright 2007, Jérôme Duval. All rights reserved.
+ * Copyright 2007-2009, Jérôme Duval. All rights reserved.
  * Distributed under the terms of the MIT License.
  */
 
@@ -14,16 +14,16 @@
 
 #define MEDIA_SOUNDS_BEEP				"Beep"
 #define MEDIA_SOUNDS_STARTUP			"Startup"
-#define MEDIA_SOUNDS_KEY_DOWN			"Key Down"
-#define MEDIA_SOUNDS_KEY_REPEAT			"Key Repeat"
-#define MEDIA_SOUNDS_KEY_UP				"Key Up"
-#define MEDIA_SOUNDS_MOUSE_DOWN			"Mouse Down"
-#define MEDIA_SOUNDS_MOUSE_UP			"Mouse Up"
-#define MEDIA_SOUNDS_WINDOW_ACTIVATED	"Window Activated"
-#define MEDIA_SOUNDS_WINDOW_CLOSE		"Window Close"
-#define MEDIA_SOUNDS_WINDOW_MINIMIZED	"Window Minimized"
-#define MEDIA_SOUNDS_WINDOW_OPEN		"Window Open"
-#define MEDIA_SOUNDS_WINDOW_RESTORED	"Window Restored"
-#define MEDIA_SOUNDS_WINDOW_ZOOMED		"Window Zoomed"
+#define MEDIA_SOUNDS_KEY_DOWN			"Key down"
+#define MEDIA_SOUNDS_KEY_REPEAT			"Key repeat"
+#define MEDIA_SOUNDS_KEY_UP				"Key up"
+#define MEDIA_SOUNDS_MOUSE_DOWN			"Mouse down"
+#define MEDIA_SOUNDS_MOUSE_UP			"Mouse up"
+#define MEDIA_SOUNDS_WINDOW_ACTIVATED	"Window activated"
+#define MEDIA_SOUNDS_WINDOW_CLOSE		"Window close"
+#define MEDIA_SOUNDS_WINDOW_MINIMIZED	"Window minimized"
+#define MEDIA_SOUNDS_WINDOW_OPEN		"Window open"
+#define MEDIA_SOUNDS_WINDOW_RESTORED	"Window restored"
+#define MEDIA_SOUNDS_WINDOW_ZOOMED		"Window zoomed"
 
 #endif // _MEDIA_SOUNDS_H