Index: src/add-ons/print/drivers/preview/PageSetupWindow.cpp
===================================================================
--- src/add-ons/print/drivers/preview/PageSetupWindow.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/preview/PageSetupWindow.cpp	(Arbeitskopie)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2003-2008, Haiku. All rights reserved.
+ * Copyright 2003-2009, Haiku, Inc. All rights reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -90,14 +90,14 @@
 
 
 PageSetupWindow::PageSetupWindow(BMessage *msg, const char *printerName)
-	:	BlockingWindow(BRect(0,0,400,220), "Page Setup", B_TITLED_WINDOW_LOOK,
+	:	BlockingWindow(BRect(0,0,400,220), "Page setup", B_TITLED_WINDOW_LOOK,
  			B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE | B_NOT_MINIMIZABLE |
  			B_NOT_ZOOMABLE),
 	fSetupMsg(msg),
 	fPrinterDirName(printerName)
 {
 	if (printerName)
-		SetTitle(BString(printerName).Append(" Page Setup").String());
+		SetTitle(BString(printerName).Append(" Page setup").String());
 
 	// load orientation
 	if (fSetupMsg->FindInt32("orientation", &fCurrentOrientation) != B_OK)
@@ -147,12 +147,12 @@
 	panel->AddChild(fMarginView);
 	fMarginView->SetResizingMode(B_FOLLOW_NONE);
 
-	BPopUpMenu* m = new BPopUpMenu("Page Size");
+	BPopUpMenu* m = new BPopUpMenu("Page size");
 	m->SetRadioMode(true);
 
 	bounds.OffsetBy(bounds.Width() + 10.0, 5.0);
 	float divider = be_plain_font->StringWidth("Orientation: ");
-	fPageSizeMenu = new BMenuField(bounds, "page_size", "Page Size:", m);
+	fPageSizeMenu = new BMenuField(bounds, "page_size", "Page size:", m);
 	panel->AddChild(fPageSizeMenu);
 	fPageSizeMenu->ResizeToPreferred();
 	fPageSizeMenu->SetDivider(divider);
Index: src/add-ons/print/drivers/pcl5/PCL5Entry.cpp
===================================================================
--- src/add-ons/print/drivers/pcl5/PCL5Entry.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/pcl5/PCL5Entry.cpp	(Arbeitskopie)
@@ -1,7 +1,7 @@
 /*
  * PCL5Entry.cpp
  * Copyright 1999-2000 Y.Takagi. All Rights Reserved.
- * Copyright 2003 Michael Pfeiffer.
+ * Copyright 2003-2009 Michael Pfeiffer.
  */
 
 #include "PCL5.h"
@@ -20,7 +20,7 @@
 	
 	const char* GetDriverName() const 
 	{ 
-		return "PCL5 Compatible"; 
+		return "PCL5 compatible"; 
 	}
 	
 	const char* GetVersion() const    
Index: src/add-ons/print/drivers/pcl6/PCL6Entry.cpp
===================================================================
--- src/add-ons/print/drivers/pcl6/PCL6Entry.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/pcl6/PCL6Entry.cpp	(Arbeitskopie)
@@ -1,7 +1,7 @@
 /*
  * PCL6Entry.cpp
  * Copyright 1999-2000 Y.Takagi. All Rights Reserved.
- * Copyright 2003 Michael Pfeiffer.
+ * Copyright 2003-2009 Michael Pfeiffer.
  */
 
 #include "PCL6.h"
@@ -20,7 +20,7 @@
 	
 	const char* GetDriverName() const 
 	{ 
-		return "PCL6 Compatible"; 
+		return "PCL6 compatible"; 
 	}
 	
 	const char* GetVersion() const    
Index: src/add-ons/print/drivers/canon_lips/lips3/Lips3Entry.cpp
===================================================================
--- src/add-ons/print/drivers/canon_lips/lips3/Lips3Entry.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/canon_lips/lips3/Lips3Entry.cpp	(Arbeitskopie)
@@ -1,6 +1,7 @@
 /*
  * Lips3Entry.cpp
  * Copyright 1999-2000 Y.Takagi. All Rights Reserved.
+ * Copyright 2009, Haiku, Inc. All rights reserved.
  */
 
 #include "Lips3.h"
@@ -19,7 +20,7 @@
 	
 	const char* GetDriverName() const 
 	{ 
-		return "Canon LIPS3 Compatible"; 
+		return "Canon LIPS3 compatible"; 
 	}
 	
 	const char* GetVersion() const    
Index: src/add-ons/print/drivers/canon_lips/lips4/Lips4Entry.cpp
===================================================================
--- src/add-ons/print/drivers/canon_lips/lips4/Lips4Entry.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/canon_lips/lips4/Lips4Entry.cpp	(Arbeitskopie)
@@ -1,6 +1,7 @@
 /*
  * Lips4Entry.cpp
  * Copyright 1999-2000 Y.Takagi. All Rights Reserved.
+ * Copyright 2009, Haiku, Inc. All rights reserved.
  */
 
 #include "Lips4.h"
@@ -19,7 +20,7 @@
 	
 	const char* GetDriverName() const 
 	{ 
-		return "Canon LIPS4 Compatible"; 
+		return "Canon LIPS4 compatible"; 
 	}
 	
 	const char* GetVersion() const    
Index: src/add-ons/print/drivers/pdf/source/PageSetupWindow.cpp
===================================================================
--- src/add-ons/print/drivers/pdf/source/PageSetupWindow.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/pdf/source/PageSetupWindow.cpp	(Arbeitskopie)
@@ -4,7 +4,8 @@
 
 Version: 12.19.2000
 
-Copyright (c) 2001 OpenBeOS.
+Copyright (c) 2001, OpenBeOS.
+Copyright (c) 2009, Haiku, Inc. All rights reserved.
 
 Authors:
 	Philippe Houdoin
@@ -92,7 +93,7 @@
 
 
 PageSetupWindow::PageSetupWindow(BMessage *msg, const char *printerName)
-	: HWindow(BRect(0,0,400,220), "Page Setup", B_TITLED_WINDOW_LOOK,
+	: HWindow(BRect(0,0,400,220), "Page setup", B_TITLED_WINDOW_LOOK,
  		B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE | B_NOT_MINIMIZABLE |
  		B_NOT_ZOOMABLE),
 	 fResult(B_ERROR),
@@ -103,7 +104,7 @@
 	fExitSem 	= create_sem(0, "PageSetup");
 
 	if (printerName)
-		SetTitle(BString(printerName).Append(" Page Setup").String());
+		SetTitle(BString(printerName).Append(" Page setup").String());
 
 	if (fSetupMsg->FindInt32("orientation", &fCurrentOrientation) != B_OK)
 		fCurrentOrientation = PrinterDriver::PORTRAIT_ORIENTATION;
@@ -165,12 +166,12 @@
 	panel->AddChild(fMarginView);
 	fMarginView->SetResizingMode(B_FOLLOW_NONE);
 
-	BPopUpMenu* m = new BPopUpMenu("Page Size");
+	BPopUpMenu* m = new BPopUpMenu("Page size");
 	m->SetRadioMode(true);
 
 	bounds.OffsetBy(bounds.Width() + 10.0, 5.0);
-	float divider = be_plain_font->StringWidth("PDF Compatibility: ");
-	fPageSizeMenu = new BMenuField(bounds, "page_size", "Page Size:", m);
+	float divider = be_plain_font->StringWidth("PDF compatibility: ");
+	fPageSizeMenu = new BMenuField(bounds, "page_size", "Page size:", m);
 	panel->AddChild(fPageSizeMenu);
 	fPageSizeMenu->ResizeToPreferred();
 	fPageSizeMenu->SetDivider(divider);
@@ -207,12 +208,12 @@
 			item->SetMarked(true);
 	}
 
-	m = new BPopUpMenu("PDF Compatibility");
+	m = new BPopUpMenu("PDF compatibility");
 	m->SetRadioMode(true);
 
 	bounds.OffsetBy(0.0, fOrientationMenu->Bounds().Height() + 10.0);
 	fPDFCompatibilityMenu = new BMenuField(bounds, "pdf_compatibility",
-		"PDF Compatibility:", m);
+		"PDF compatibility:", m);
 	panel->AddChild(fPDFCompatibilityMenu);
 	fPDFCompatibilityMenu->ResizeToPreferred();
 	fPDFCompatibilityMenu->SetDivider(divider);
Index: src/add-ons/print/drivers/postscript/PSEntry.cpp
===================================================================
--- src/add-ons/print/drivers/postscript/PSEntry.cpp	(Revision 34761)
+++ src/add-ons/print/drivers/postscript/PSEntry.cpp	(Arbeitskopie)
@@ -1,7 +1,7 @@
 /*
  * PSEntry.cpp
  * Copyright 1999-2000 Y.Takagi. All Rights Reserved.
- * Copyright 2003 Michael Pfeiffer.
+ * Copyright 2003-2009 Michael Pfeiffer.
  */
 
 #include "PS.h"
@@ -20,7 +20,7 @@
 	
 	const char* GetDriverName() const 
 	{ 
-		return "PS Compatible"; 
+		return "PS compatible"; 
 	}
 	
 	const char* GetVersion() const    