diff --git a/src/system/ldscripts/arm/boot_loader_u-boot.ld b/src/system/ldscripts/arm/boot_loader_u-boot.ld
index db108f9..70176e6 100644
--- a/src/system/ldscripts/arm/boot_loader_u-boot.ld
+++ b/src/system/ldscripts/arm/boot_loader_u-boot.ld
@@ -26,7 +26,7 @@ SECTIONS
 	.ARM.exidx   : { *(.ARM.exidx* .gnu.linkonce.armexidx.*) }
 	__exidx_end = .;
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/arm/kernel.ld b/src/system/ldscripts/arm/kernel.ld
index 748d55d..00500f4 100644
--- a/src/system/ldscripts/arm/kernel.ld
+++ b/src/system/ldscripts/arm/kernel.ld
@@ -83,7 +83,7 @@ SECTIONS
 
 	__data_end = .;
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	. = ALIGN(4);
 	__bss_start = .;
 	.bss : { *(.bss .bss.*) }
diff --git a/src/system/ldscripts/m68k/add-on.ld b/src/system/ldscripts/m68k/add-on.ld
index 37aca02..b24810c 100644
--- a/src/system/ldscripts/m68k/add-on.ld
+++ b/src/system/ldscripts/m68k/add-on.ld
@@ -53,7 +53,7 @@ SECTIONS
 	.got : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 	
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/m68k/app.ld b/src/system/ldscripts/m68k/app.ld
index 9c46e7f..371ee35 100644
--- a/src/system/ldscripts/m68k/app.ld
+++ b/src/system/ldscripts/m68k/app.ld
@@ -60,7 +60,7 @@ SECTIONS
     .got	 : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/m68k/boot_loader_amiga.ld b/src/system/ldscripts/m68k/boot_loader_amiga.ld
index 07d8044..996d78b 100644
--- a/src/system/ldscripts/m68k/boot_loader_amiga.ld
+++ b/src/system/ldscripts/m68k/boot_loader_amiga.ld
@@ -30,7 +30,7 @@ SECTIONS
 	.got : { *(.got .got2) }
 	.sdata : { *(.sdata .sdata.* .gnu.linkonce.s.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.sbss : { *(.sbss .sbss.* .gnu.linkonce.sb.*) }
 	.bss : {
diff --git a/src/system/ldscripts/m68k/boot_loader_apple.ld b/src/system/ldscripts/m68k/boot_loader_apple.ld
index 07d8044..996d78b 100644
--- a/src/system/ldscripts/m68k/boot_loader_apple.ld
+++ b/src/system/ldscripts/m68k/boot_loader_apple.ld
@@ -30,7 +30,7 @@ SECTIONS
 	.got : { *(.got .got2) }
 	.sdata : { *(.sdata .sdata.* .gnu.linkonce.s.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.sbss : { *(.sbss .sbss.* .gnu.linkonce.sb.*) }
 	.bss : {
diff --git a/src/system/ldscripts/m68k/boot_loader_atari_m68k.ld b/src/system/ldscripts/m68k/boot_loader_atari_m68k.ld
index a59ecfe..8140561 100644
--- a/src/system/ldscripts/m68k/boot_loader_atari_m68k.ld
+++ b/src/system/ldscripts/m68k/boot_loader_atari_m68k.ld
@@ -22,7 +22,7 @@ SECTIONS
 	__data_start = .;
 	.data : { *(.data .gnu.linkonce.d.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/m68k/boot_prg_atari_m68k.ld b/src/system/ldscripts/m68k/boot_prg_atari_m68k.ld
index b593e29..20d2be7 100755
--- a/src/system/ldscripts/m68k/boot_prg_atari_m68k.ld
+++ b/src/system/ldscripts/m68k/boot_prg_atari_m68k.ld
@@ -55,7 +55,7 @@ SECTIONS
 	/*	*(.rel.data) *(.rel.gnu.linkonce.d*)
 		*(.rela.data) *(.rela.gnu.linkonce.d*) */
 	}
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : {
 		*(.bss)
diff --git a/src/system/ldscripts/m68k/kernel.ld b/src/system/ldscripts/m68k/kernel.ld
index 9d8a872..35cbc5a 100644
--- a/src/system/ldscripts/m68k/kernel.ld
+++ b/src/system/ldscripts/m68k/kernel.ld
@@ -62,7 +62,7 @@ SECTIONS
 	.got : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) } :dynamic :data
 	
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) } :data
 
diff --git a/src/system/ldscripts/m68k/library.ld b/src/system/ldscripts/m68k/library.ld
index 9231d54..87afcae 100644
--- a/src/system/ldscripts/m68k/library.ld
+++ b/src/system/ldscripts/m68k/library.ld
@@ -62,7 +62,7 @@ SECTIONS
 	.dynamic : { *(.dynamic) }
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/m68k/runtime_loader.ld b/src/system/ldscripts/m68k/runtime_loader.ld
index 8c89c18..853d583 100644
--- a/src/system/ldscripts/m68k/runtime_loader.ld
+++ b/src/system/ldscripts/m68k/runtime_loader.ld
@@ -51,7 +51,7 @@ SECTIONS
 	PROVIDE (__ctor_end = .);
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/m68k/stage2.ld b/src/system/ldscripts/m68k/stage2.ld
index 26ff7d2..5113201 100644
--- a/src/system/ldscripts/m68k/stage2.ld
+++ b/src/system/ldscripts/m68k/stage2.ld
@@ -20,7 +20,7 @@ SECTIONS
 	__data_start = .;
 	.data : { *(.data .gnu.linkonce.d.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/mipsel/boot_loader_routerboard_mipsel.ld b/src/system/ldscripts/mipsel/boot_loader_routerboard_mipsel.ld
index 616eebf..6c3df3f 100644
--- a/src/system/ldscripts/mipsel/boot_loader_routerboard_mipsel.ld
+++ b/src/system/ldscripts/mipsel/boot_loader_routerboard_mipsel.ld
@@ -22,7 +22,7 @@ SECTIONS
 	_gp = .;
 		/* needed for GPREL16 relocation to small-data section */
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/ppc/add-on.ld b/src/system/ldscripts/ppc/add-on.ld
index 23a73ac..cacc332 100644
--- a/src/system/ldscripts/ppc/add-on.ld
+++ b/src/system/ldscripts/ppc/add-on.ld
@@ -53,7 +53,7 @@ SECTIONS
 	.got : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 	
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/ppc/app.ld b/src/system/ldscripts/ppc/app.ld
index 5185878..410d5ec 100644
--- a/src/system/ldscripts/ppc/app.ld
+++ b/src/system/ldscripts/ppc/app.ld
@@ -60,7 +60,7 @@ SECTIONS
     .got	 : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/ppc/boot_loader_openfirmware.ld b/src/system/ldscripts/ppc/boot_loader_openfirmware.ld
index b131fa5..327e7c4 100644
--- a/src/system/ldscripts/ppc/boot_loader_openfirmware.ld
+++ b/src/system/ldscripts/ppc/boot_loader_openfirmware.ld
@@ -30,7 +30,7 @@ SECTIONS
 	.got : { *(.got .got2) }
 	.sdata : { *(.sdata .sdata.* .gnu.linkonce.s.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.sbss : { *(.sbss .sbss.* .gnu.linkonce.sb.*) }
 	.bss : {
diff --git a/src/system/ldscripts/ppc/kernel.ld b/src/system/ldscripts/ppc/kernel.ld
index c76421c..44e73c5 100644
--- a/src/system/ldscripts/ppc/kernel.ld
+++ b/src/system/ldscripts/ppc/kernel.ld
@@ -81,7 +81,7 @@ SECTIONS
 	
 	.sdata : { *(.sdata .sdata.* .gnu.linkonce.s.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	__bss_start = .;
 	.sbss : { *(.sbss .sbss.* .gnu.linkonce.sb.*) }
diff --git a/src/system/ldscripts/ppc/library.ld b/src/system/ldscripts/ppc/library.ld
index 50735ed..24d0112 100644
--- a/src/system/ldscripts/ppc/library.ld
+++ b/src/system/ldscripts/ppc/library.ld
@@ -62,7 +62,7 @@ SECTIONS
 	.dynamic : { *(.dynamic) }
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/ppc/runtime_loader.ld b/src/system/ldscripts/ppc/runtime_loader.ld
index 55698b1..908df7f 100644
--- a/src/system/ldscripts/ppc/runtime_loader.ld
+++ b/src/system/ldscripts/ppc/runtime_loader.ld
@@ -51,7 +51,7 @@ SECTIONS
 	PROVIDE (__ctor_end = .);
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/ppc/stage2.ld b/src/system/ldscripts/ppc/stage2.ld
index dcdbe62..bfb268d 100644
--- a/src/system/ldscripts/ppc/stage2.ld
+++ b/src/system/ldscripts/ppc/stage2.ld
@@ -20,7 +20,7 @@ SECTIONS
 	__data_start = .;
 	.data : { *(.data .gnu.linkonce.d.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/sh4/library.ld b/src/system/ldscripts/sh4/library.ld
index 98553d8..604ff9c 100644
--- a/src/system/ldscripts/sh4/library.ld
+++ b/src/system/ldscripts/sh4/library.ld
@@ -61,7 +61,7 @@ SECTIONS
 	.dynamic : { *(.dynamic) }
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/add-on.ld b/src/system/ldscripts/x86/add-on.ld
index d3e9d6d..07496e6 100644
--- a/src/system/ldscripts/x86/add-on.ld
+++ b/src/system/ldscripts/x86/add-on.ld
@@ -54,7 +54,7 @@ SECTIONS
 	.got : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 	
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/app.ld b/src/system/ldscripts/x86/app.ld
index c2d2eab..2bcd6ca 100644
--- a/src/system/ldscripts/x86/app.ld
+++ b/src/system/ldscripts/x86/app.ld
@@ -60,7 +60,7 @@ SECTIONS
     .got	 : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/boot_loader_bios_ia32.ld b/src/system/ldscripts/x86/boot_loader_bios_ia32.ld
index b108d16..6cc9efd 100644
--- a/src/system/ldscripts/x86/boot_loader_bios_ia32.ld
+++ b/src/system/ldscripts/x86/boot_loader_bios_ia32.ld
@@ -21,7 +21,7 @@ SECTIONS
 	__data_start = .;
 	.data : { *(.data .gnu.linkonce.d.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/boot_loader_pxe_ia32.ld b/src/system/ldscripts/x86/boot_loader_pxe_ia32.ld
index b108d16..6cc9efd 100644
--- a/src/system/ldscripts/x86/boot_loader_pxe_ia32.ld
+++ b/src/system/ldscripts/x86/boot_loader_pxe_ia32.ld
@@ -21,7 +21,7 @@ SECTIONS
 	__data_start = .;
 	.data : { *(.data .gnu.linkonce.d.*) }
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/kernel.ld b/src/system/ldscripts/x86/kernel.ld
index 7324b69..37f6bd7 100644
--- a/src/system/ldscripts/x86/kernel.ld
+++ b/src/system/ldscripts/x86/kernel.ld
@@ -54,7 +54,7 @@ SECTIONS
 	.got : { *(.got.plt) *(.got) }
 	.dynamic : { *(.dynamic) }
 	
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	__bss_start = .;
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/library.ld b/src/system/ldscripts/x86/library.ld
index db0e095..c490cd2 100644
--- a/src/system/ldscripts/x86/library.ld
+++ b/src/system/ldscripts/x86/library.ld
@@ -62,7 +62,7 @@ SECTIONS
 	.dynamic : { *(.dynamic) }
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 
diff --git a/src/system/ldscripts/x86/runtime_loader.ld b/src/system/ldscripts/x86/runtime_loader.ld
index 7672084..2bc53c6 100644
--- a/src/system/ldscripts/x86/runtime_loader.ld
+++ b/src/system/ldscripts/x86/runtime_loader.ld
@@ -51,7 +51,7 @@ SECTIONS
 	PROVIDE (__ctor_end = .);
 
 
-	/* unintialized data (in same segment as writable data) */
+	/* uninitialized data (in same segment as writable data) */
 	PROVIDE (__bss_start = .);
 	.bss : { *(.bss) }
 